Subject: Re: [PATCH] net: optimize Berkeley Packet Filter (BPF) processing

From: Stephen Hemminger <[email-masked]>
Date: Sat, 19 Jun 2010 22:16:11 -0700

On Sun, 20 Jun 2010 05:05:36 +0200
Hagen Paul Pfeifer <[email-masked]> wrote:

> Gcc is currenlty not in the ability to optimize the switch statement in
> sk_run_filter() because of dense case labels. This patch replace the
> OR'd labels with ordered sequenced case labels. The sk_chk_filter()
> function is modified to patch/replace the original OPCODES in a
> ordered but equivalent form. gcc is now in the ability to transform the
> switch statement in sk_run_filter into a jump table of complexity O(1).
> 
> Until this patch gcc generates a sequence of conditional branches (O(n) of 567
> byte .text segment size (arch x86_64):

I don't think this works because it breaks ABI compatibility for applications tha
use older versions.